use rand::prelude::*;
use ring_compat::signature::ed25519::SigningKey;
use rusqlite::Connection;
use tokio::sync::Mutex;

pub struct AppState {
	pub db: Connection,
	pub last_sync: i64,
	pub id: u64,
	pub key: SigningKey,
}

impl AppState {
	pub fn new() -> Self {
		let db = Connection::open_in_memory()
			.expect("Failed to create DB.");
		db.execute(
			"CREATE TABLE swap (
				rand INTEGER,
				store INTEGER,
				account INTEGER,
				submitter INTEGER,
				time INTEGER,
				cancellation BOOL
			)",
			(),
		)
		.unwrap();
		let mut rng = rand::thread_rng();
		let last_sync = i64::MIN;
		let id = rng.gen();
		let key = SigningKey::generate(&mut rng);
		AppState {
			db,
			last_sync,
			id,
			key,
		}
	}
}
